diff --git a/extras/features/com.jboss.jbds.subclipse.feature/feature.properties b/extras/features/com.jboss.jbds.subclipse.feature/feature.properties
index 89ff309..83126f4 100644
--- a/extras/features/com.jboss.jbds.subclipse.feature/feature.properties
+++ b/extras/features/com.jboss.jbds.subclipse.feature/feature.properties
@@ -1,5 +1,5 @@
 ###############################################################################
-# Copyright (c) 2011 Red Hat, Inc. and others.
+# Copyright (c) 2012 Red Hat, Inc. and others.
 # All rights reserved. This program and the accompanying materials 
 # are made available under the terms of the Eclipse Public License v1.0
 # which accompanies this distribution, and is available at
@@ -14,4 +14,4 @@
 # java.io.Properties file (ISO 8859-1 with "\" escapes)
 # This file should be translated.
 
-copyright=JBoss, Home of Professional Open Source\nCopyright Red Hat, Inc., and individual contributors as indicated\nby the @authors tag, 2011. See the copyright.txt in the distribution\nfor a full listing of individual contributors.
\ No newline at end of file
+copyright=JBoss, Home of Professional Open Source\nCopyright Red Hat, Inc., and individual contributors as indicated\nby the @authors tag, 2012. See the copyright.txt in the distribution\nfor a full listing of individual contributors.
\ No newline at end of file
diff --git a/extras/features/com.jboss.jbds.subclipse.feature/feature.xml b/extras/features/com.jboss.jbds.subclipse.feature/feature.xml
index b4407c1..2c2db97 100644
--- a/extras/features/com.jboss.jbds.subclipse.feature/feature.xml
+++ b/extras/features/com.jboss.jbds.subclipse.feature/feature.xml
@@ -2,11 +2,11 @@
 <feature
       id="com.jboss.jbds.subclipse.feature"
       label="Subclipse (Selected)"
-      version="1.0.0.qualifier"
+      version="1.0.1.qualifier"
       provider-name="JBoss by RedHat">
 
    <description>
-Contains Subclipse 1.6 and SVNKit 1.3, including Mylyn support (Selected). 
+Contains Subclipse 1.6 and SVNKit 1.3 (Selected). 
 Features selected by Red Hat for use with JBoss Developer Studio. 
    </description>
 
@@ -145,7 +145,6 @@ AND CONDITIONS PRIOR TO USE OF THIS CONTENT.
 		<import feature="org.tigris.subversion.clientadapter.javahl.feature" version="1.6.15" match="compatible"/>
 		<import feature="org.tigris.subversion.clientadapter.svnkit.feature" version="1.6.15" match="compatible"/>
 		<import feature="org.tigris.subversion.subclipse.graph.feature" version="1.0.9" match="compatible"/>
-		<import feature="org.tigris.subversion.subclipse.mylyn" version="3.0.0" match="compatible"/>
 		<import feature="org.tigris.subversion.subclipse" version="1.6.17" match="compatible"/>
 		<import feature="org.tmatesoft.svnkit" version="1.3.5.7406" match="compatible"/>
    </requires>
diff --git a/extras/features/com.jboss.jbds.subclipse.feature/pom.xml b/extras/features/com.jboss.jbds.subclipse.feature/pom.xml
index 6c47d6a..6fd512e 100644
--- a/extras/features/com.jboss.jbds.subclipse.feature/pom.xml
+++ b/extras/features/com.jboss.jbds.subclipse.feature/pom.xml
@@ -9,6 +9,6 @@
 	</parent>
 	<groupId>com.jboss.jbds.extras.features</groupId>
 	<artifactId>com.jboss.jbds.subclipse.feature</artifactId>
-	<version>1.0.0-SNAPSHOT</version>
+	<version>1.0.1-SNAPSHOT</version>
 	<packaging>eclipse-feature</packaging>
 </project>
diff --git a/extras/features/pom.xml b/extras/features/pom.xml
index c5f9913..ffd482a 100644
--- a/extras/features/pom.xml
+++ b/extras/features/pom.xml
@@ -13,25 +13,25 @@
 	<name>JBDS Extra Features</name>
 	<packaging>pom</packaging>
 	<modules>
-		<!-- DEPRECATED. see JBDS-1717 <module>com.jboss.jbds.product.extra.feature</module> -->
-
-		<!--  JBDS 4.0 -->
+		<!--  JBDS 4.x -->
 		<module>com.jboss.jbds.testng.feature</module>
 		<module>com.jboss.jbds.springide.feature</module>
-
-		<!--  JBDS 4.1 -->
-		<!-- moved in 5.0 to SOA Tooling site <module>com.jboss.jbds.bpel.feature</module> -->
 		<module>com.jboss.jbds.findbugs.feature</module>
 		<module>com.jboss.jbds.git.mylyn.feature</module>
 		<module>com.jboss.jbds.mylyn.feature</module>
 		<module>com.jboss.jbds.pmd.feature</module>
-		<module>com.jboss.jbds.subclipse.feature</module>
 
 		<!-- JBDS 5.0 -->
+		<!-- moved in 5.0 to SOA Tooling site <module>com.jboss.jbds.bpel.feature</module> -->
 		<!-- JBDS-2189 remove <module>com.jboss.jbds.jslint.feature</module> -->
 		<module>com.jboss.jbds.m2e.extras.feature</module>
 		<module>com.jboss.jbds.eclipsecs.feature</module>
 		<module>com.jboss.jbds.gwt.feature</module>
+
+		<!-- JBDS 5.0.1 restructured -->
+		<module>com.jboss.jbds.subclipse.feature</module>
+		<!-- JBDS-2221 remove mylyn support from subclipse feature -->
+		<module>com.jboss.jbds.subclipse.mylyn.feature</module>
 	</modules>
 </project>
 	
diff --git a/extras/site/site.xml b/extras/site/site.xml
index 5cb34a1..0cf4ef7 100644
--- a/extras/site/site.xml
+++ b/extras/site/site.xml
@@ -113,6 +113,9 @@ Features selected by Red Hat for use with JBoss Developer Studio.
 	<feature url="features/com.jboss.jbds.subclipse.feature_0.0.0.jar" id="com.jboss.jbds.subclipse.feature" version="0.0.0">
 		<category name="JBoss Selected Features" />
 	</feature>
+	<feature url="features/com.jboss.jbds.subclipse.mylyn.feature_0.0.0.jar" id="com.jboss.jbds.subclipse.mylyn.feature" version="0.0.0">
+		<category name="JBoss Selected Features" />
+	</feature>
 	
 	<!-- JBDS 5.0 -->
 	
diff --git a/product/plugins/com.jboss.jbds.central.discovery/plugin.xml b/product/plugins/com.jboss.jbds.central.discovery/plugin.xml
index b4f8380..cd72abc 100644
--- a/product/plugins/com.jboss.jbds.central.discovery/plugin.xml
+++ b/product/plugins/com.jboss.jbds.central.discovery/plugin.xml
@@ -289,8 +289,25 @@
             name="Subclipse + SVNKit"
             provider="tigris.org"
             siteUrl="http://devstudio.jboss.com/updates/5.0/central/core/">
-            <iu id="org.tigris.subversion.subclipse"/>
-            <iu id="org.tigris.subversion.clientadapter.svnkit.feature"/>
+            <iu id="com.jboss.jbds.subclipse.feature"/>
+         <icon
+               image32="images/subclipse_32.gif">
+         </icon>
+         <overview
+               url="http://subclipse.tigris.org/">
+         </overview>
+      </connectorDescriptor>
+      <connectorDescriptor
+            categoryId="org.jboss.tools.central.discovery.scm"
+            groupId="org.jboss.tools.central.discovery.scm.svn"
+            description="Mylyn support for the Subversion version control system, including SVNKit"
+            id="org.tigris.subversion.subclipse"
+            kind="task"
+            license="Free, Subclipse License"
+            name="Mylyn for Subclipse + SVNKit"
+            provider="tigris.org"
+            siteUrl="http://devstudio.jboss.com/updates/5.0/central/core/">
+            <iu id="com.jboss.jbds.subclipse.mylyn.feature"/>
          <icon
                image32="images/subclipse_32.gif">
          </icon>