Index: ejb3/build.xml
===================================================================
--- ejb3/build.xml	(revision 113255)
+++ ejb3/build.xml	(working copy)
@@ -99,7 +99,10 @@
          <path refid="apache.logging.classpath"/>
          <path refid="jboss.jboss.cl.classpath"/>
          <path refid="org.jboss.cluster.classpath"/>
+         <path refid="jboss.jboss.javaee.classpath"/>
+         	<!--
          <path refid="jboss.jboss.jaspi.api.classpath"/>
+         -->
          <path refid="jboss.jboss.security.spi.classpath"/>
          <path refid="jboss.jbosssx.classpath"/>
          <path refid="jboss.security.int.classpath"/>
Index: tomcat/build.xml
===================================================================
--- tomcat/build.xml	(revision 113255)
+++ tomcat/build.xml	(working copy)
@@ -93,7 +93,9 @@
     <path id="dependentmodule.classpath">
       <path refid="hibernate.entitymanager.classpath"/>
       <path refid="jboss.jboss.javaee.classpath"/>
+      	<!--
       <path refid="jboss.jboss.jaspi.api.classpath"/>
+      -->
       <path refid="jboss.jboss.bootstrap.classpath"/>
       <path refid="jboss.system.classpath"/>
       <path refid="jboss.systemjmx.classpath"/>
Index: thirdparty/pom.xml
===================================================================
--- thirdparty/pom.xml	(revision 113255)
+++ thirdparty/pom.xml	(working copy)
@@ -775,19 +775,22 @@
               </mapping>
             </dependency>
             <dependency>
-              <groupId>org.jboss.javaee</groupId>
-              <artifactId>jboss-javaee</artifactId>
+              <groupId>org.jboss.spec.</groupId>
+              <artifactId>jboss-javaee-5.0-all</artifactId>
               <mapping>
                 <componentId>jboss.jboss-javaee</componentId>
+                <artifactId>jboss-javaee</artifactId>
               </mapping>
             </dependency>
+            <!-- 
             <dependency>
               <groupId>org.jboss.javaee</groupId>
-              <artifactId>jboss-jaspi-api</artifactId>
+              <artifactId>jboss-jaspi-api-1.0_spec</artifactId>
               <mapping>
                 <componentId>jboss.jboss-jaspi-api</componentId>
               </mapping>
             </dependency>
+             -->
             <dependency>
               <groupId>org.jboss.microcontainer</groupId>
               <artifactId>jboss-aop-mc-int</artifactId>
@@ -1644,12 +1647,13 @@
     </dependency>
     
     <dependency>
-      <groupId>org.jboss.javaee</groupId>
-      <artifactId>jboss-javaee</artifactId>
+      <groupId>org.jboss.spec.</groupId>
+      <artifactId>jboss-javaee-5.0-all</artifactId>
     </dependency>
+    <!-- 
     <dependency>
       <groupId>org.jboss.javaee</groupId>
-      <artifactId>jboss-ejb-api</artifactId>
+      <artifactId>jboss-ejb-api-3.0_spec</artifactId>
     </dependency>
     <dependency>
       <groupId>org.jboss.javaee</groupId>
@@ -1657,24 +1661,25 @@
     </dependency>
     <dependency>
       <groupId>org.jboss.javaee</groupId>
-      <artifactId>jboss-jad-api</artifactId>
+      <artifactId>jboss-jad-api-1.2_spec</artifactId>
     </dependency>
     <dependency>
       <groupId>org.jboss.javaee</groupId>
-      <artifactId>jboss-jaspi-api</artifactId>
+      <artifactId>jboss-jaspi-api-1.0_spec</artifactId>
     </dependency>
     <dependency>
       <groupId>org.jboss.javaee</groupId>
-      <artifactId>jboss-jca-api</artifactId>
+      <artifactId>jboss-jca-api-1.5_spec</artifactId>
     </dependency>
     <dependency>
       <groupId>org.jboss.javaee</groupId>
-      <artifactId>jboss-jms-api</artifactId>
+      <artifactId>jboss-jms-api-1.1_spec</artifactId>
     </dependency>
     <dependency>
       <groupId>org.jboss.javaee</groupId>
-      <artifactId>jboss-transaction-api</artifactId>
+      <artifactId>jboss-transaction-api-1.0.1_spec</artifactId>
     </dependency>
+     -->
     <dependency>
       <groupId>org.jboss.jopr</groupId>
       <artifactId>jopr-embedded-jbas5</artifactId>
Index: component-matrix/pom.xml
===================================================================
--- component-matrix/pom.xml	(revision 113255)
+++ component-matrix/pom.xml	(working copy)
@@ -74,6 +74,11 @@
     <version.org.jboss.deployers>2.0.10.GA</version.org.jboss.deployers>
     <version.org.jboss.ejb3.bom>1.0.3</version.org.jboss.ejb3.bom>
     <version.org.jboss.integration>5.1.0.SP1</version.org.jboss.integration>
+    <version.org.jboss.javaee.all>1.0.0-SNAPSHOT</version.org.jboss.javaee.all>
+    <!-- 
+    <version.org.jboss.javaee.component>5.0.2-SNAPSHOT</version.org.jboss.javaee.component>
+    <version.org.jboss.javaee.jacc>1.1.0.GA_SP1</version.org.jboss.javaee.jacc>
+    -->
     <version.org.jboss.jbossxb>2.0.1.GA</version.org.jboss.jbossxb>
     <version.org.jboss.jopr>1.3.4.SP5</version.org.jboss.jopr>    
     <version.org.jboss.jpa>1.0.0.SP1</version.org.jboss.jpa>
@@ -99,7 +104,6 @@
     <version.seam.integration>5.1.0.GA</version.seam.integration>
     <version.staxex>1.2</version.staxex>
     <version.streambuffer>0.8</version.streambuffer>
-    <version.suffix.org.jboss.javaee>.GA</version.suffix.org.jboss.javaee>
     <version.sun-jaxws>2.1.7</version.sun-jaxws>
     <version.sun.jaxb>2.1.12-patch-02</version.sun.jaxb>
     <version.sun.jaxb.api>2.1</version.sun.jaxb.api>
@@ -1880,15 +1884,15 @@
       </dependency>
 
       <dependency>
-        <groupId>org.jboss.javaee</groupId>
-        <artifactId>jboss-javaee</artifactId>
-        <version>5.0.1${version.suffix.org.jboss.javaee}</version>
+        <groupId>org.jboss.spec.</groupId>
+        <artifactId>jboss-javaee-5.0-all</artifactId>
+        <version>${version.org.jboss.javaee.all}</version>
       </dependency>
-      
+        <!-- 
       <dependency>
         <groupId>org.jboss.javaee</groupId>
-        <artifactId>jboss-ejb-api</artifactId>
-        <version>3.0.0${version.suffix.org.jboss.javaee}</version>
+        <artifactId>jboss-ejb-api-3.0_spec</artifactId>
+        <version>${version.org.jboss.javaee.component}</version>
         <exclusions>
           <exclusion>
             <groupId>javax.xml</groupId>
@@ -1900,39 +1904,39 @@
       <dependency>
         <groupId>org.jboss.javaee</groupId>
         <artifactId>jboss-jacc-api</artifactId>
-        <version>1.1.0${version.suffix.org.jboss.javaee}_SP1</version>
+        <version>${version.org.jboss.javaee.jacc}</version>
       </dependency>
       
       <dependency>
         <groupId>org.jboss.javaee</groupId>
-        <artifactId>jboss-jad-api</artifactId>
-        <version>1.2.0${version.suffix.org.jboss.javaee}</version>
+        <artifactId>jboss-jad-api-1.2_spec</artifactId>
+        <version>${version.org.jboss.javaee.component}</version>
       </dependency>
       
       <dependency>
         <groupId>org.jboss.javaee</groupId>
-        <artifactId>jboss-jaspi-api</artifactId>
-        <version>1.0.0${version.suffix.org.jboss.javaee}</version>
+        <artifactId>jboss-jaspi-api-1.0_spec</artifactId>
+        <version>${version.org.jboss.javaee.component}</version>
       </dependency>
       
       <dependency>
         <groupId>org.jboss.javaee</groupId>
-        <artifactId>jboss-jca-api</artifactId>
-        <version>1.5.0${version.suffix.org.jboss.javaee}</version>
+        <artifactId>jboss-jca-api-1.5_spec</artifactId>
+        <version>${version.org.jboss.javaee.component}</version>
       </dependency>
       
       <dependency>
         <groupId>org.jboss.javaee</groupId>
-        <artifactId>jboss-jms-api</artifactId>
-        <version>1.1.0${version.suffix.org.jboss.javaee}</version>
+        <artifactId>jboss-jms-api-1.1_spec</artifactId>
+        <version>${version.org.jboss.javaee.component}</version>
       </dependency>
 
       <dependency>
         <groupId>org.jboss.javaee</groupId>
-        <artifactId>jboss-transaction-api</artifactId>
-        <version>1.0.1${version.suffix.org.jboss.javaee}</version>
+        <artifactId>jboss-transaction-api-1.0.1_spec</artifactId>
+        <version>${version.org.jboss.javaee.component}</version>
       </dependency>
-      
+        -->
       <!-- Normally comes in via EJB3, but we may need a patched one -->
       <dependency>
         <groupId>org.jboss.jpa</groupId>
Index: server/build.xml
===================================================================
--- server/build.xml	(revision 113255)
+++ server/build.xml	(working copy)
@@ -113,7 +113,9 @@
     <path id="dependentmodule.classpath">
       <path refid="hibernate.entitymanager.classpath"/>
       <path refid="jboss.jboss.javaee.classpath"/>
+    	<!--
       <path refid="jboss.jboss.jaspi.api.classpath"/>
+      -->
       <path refid="jboss.common.core.classpath"/>
       <path refid="jboss.common.logging.spi.classpath"/>
       <path refid="jboss.common.logging.log4j.classpath"/>
Index: messaging/build.xml
===================================================================
--- messaging/build.xml	(revision 113255)
+++ messaging/build.xml	(working copy)
@@ -90,8 +90,10 @@
       <path refid="jboss.jboss.man.classpath"/>      
       <path refid="jboss.jboss.mdr.classpath"/>
       <path refid="jboss.microcontainer.classpath"/>      
-      <path refid="jboss.jbosssx.classpath"/>      
-      <path refid="jboss.jboss.jaspi.api.classpath"/>      
+      <path refid="jboss.jbosssx.classpath"/>
+    	<!--
+      <path refid="jboss.jboss.jaspi.api.classpath"/>
+      -->      
       <path refid="jboss.jboss.security.spi.classpath"/>      
       <path refid="sun.jaxb.classpath"/>
       <path refid="jboss.jbossxb.classpath"/>
Index: testsuite/build.xml
===================================================================
--- testsuite/build.xml	(revision 113255)
+++ testsuite/build.xml	(working copy)
@@ -497,7 +497,9 @@
       <path refid="jboss.iiop.classpath"/>
       <path refid="jboss.internal-server.classpath"/>
       <path refid="jboss.j2se.classpath"/>
+   	<!--
       <path refid="jboss.jboss.jaspi.api.classpath"/>
+      -->
       <path refid="jboss.jboss.javaee.classpath"/>
       <path refid="org.jboss.javaee.classpath"/>
       <path refid="jboss.jboss.vfs.classpath"/>
@@ -565,13 +567,14 @@
       <pathelement path="${jboss.dist.client}/jboss-jaspi-api.jar" />
       <!-- path refid="jboss.jboss.javaee.classpath"/ -->
       <pathelement path="${jboss.dist.client}/jboss-javaee.jar" />
-      <!-- path refid="org.jboss.javaee.classpath" / -->
+      <!-- path refid="org.jboss.javaee.classpath" / 
       <pathelement path="${org.jboss.javaee.lib}/jboss-ejb-api.jar" />
       <pathelement path="${org.jboss.javaee.lib}/jboss-jacc-api.jar" />
       <pathelement path="${org.jboss.javaee.lib}/jboss-jad-api.jar" />
       <pathelement path="${org.jboss.javaee.lib}/jboss-jca-api.jar" />
       <pathelement path="${org.jboss.javaee.lib}/jboss-jms-api.jar" />
       <pathelement path="${org.jboss.javaee.lib}/jboss-transaction-api.jar" />
+      -->
       <!-- path refid="jboss.jboss.vfs.classpath"/ -->
       <pathelement path="${jboss.dist.lib}/jboss-vfs.jar" />
       <!-- path refid="jboss.jca.classpath"/ -->
@@ -4748,7 +4751,7 @@
             value="${build.resources}/security/tst.keystore"/>
          <sysproperty key="org.jboss.security.ignoreHttpsHost" value="true"/>
          <sysproperty key="jboss.vfs.forceCopy" value="true"/>
-
+      	
          <classpath>
             <pathelement location="${build.classes}"/>
             <pathelement location="${build.resources}"/>
Index: connector/build.xml
===================================================================
--- connector/build.xml	(revision 113255)
+++ connector/build.xml	(working copy)
@@ -107,7 +107,9 @@
       <path refid="jboss.common.logging.log4j.classpath"/>
       <path refid="jboss.common.logging.jdk.classpath"/>
       <path refid="jboss.jboss.javaee.classpath"/>
+    	<!--
       <path refid="jboss.jboss.jaspi.api.classpath"/>
+      -->
       <path refid="jboss.jbosssx.classpath"/>
       <path refid="jboss.jboss.security.spi.classpath"/>
       <path refid="jboss.security.int.classpath"/>
Index: build/build-distr.xml
===================================================================
--- build/build-distr.xml	(revision 113255)
+++ build/build-distr.xml	(working copy)
@@ -2195,9 +2195,11 @@
       <fileset dir="${jboss.jboss.ejb3.ext.api.lib}">
         <include name="jboss-ejb3-ext-api.jar"/>
       </fileset>
+    	<!--
       <fileset dir="${jboss.jboss.jaspi.api.lib}">
         <include name="jboss-jaspi-api.jar"/>
       </fileset>
+      -->
       <fileset dir="${jboss.jboss.javaee.lib}">
         <include name="jboss-javaee.jar"/>
       </fileset>
@@ -2313,9 +2315,11 @@
       <fileset dir="${jboss.metadata.lib}">
         <include name="jboss-metadata.jar"/>
       </fileset>
+    	<!--
       <fileset dir="${jboss.jboss.jaspi.api.lib}">
         <include name="jboss-jaspi-api.jar"/>
       </fileset>
+      -->
       <fileset dir="${jboss.jnpserver.lib}">
         <include name="jnpserver.jar"/>
       </fileset>
Index: security/build.xml
===================================================================
--- security/build.xml	(revision 113255)
+++ security/build.xml	(working copy)
@@ -96,7 +96,9 @@
       <path refid="jboss.common.logging.jdk.classpath"/>
       <path refid="jboss.j2se.classpath"/>
       <path refid="jboss.jboss.javaee.classpath"/>
+    	<!--
       <path refid="jboss.jboss.jaspi.api.classpath"/>
+      -->
       <path refid="jboss.jbossxb.classpath"/>
       <path refid="jboss.jboss.deployers.classpath"/>
       <path refid="jboss.jboss.man.classpath"/>
Index: hornetq-int/.classpath
===================================================================
--- hornetq-int/.classpath	(revision 113255)
+++ hornetq-int/.classpath	(working copy)
@@ -37,12 +37,7 @@
 	<classpathentry kind="lib" path="/thirdparty/jboss/jboss-reflect/lib/jboss-reflect.jar" sourcepath="/thirdparty/jboss/jboss-reflect/lib/jboss-reflect-sources.jar"/>
 	<classpathentry kind="lib" path="/thirdparty/jboss/common-core/lib/jboss-common-core.jar" sourcepath="/thirdparty/jboss/common-core/lib/jboss-common-core-sources.jar"/>
 	<classpathentry kind="lib" path="/thirdparty/jboss/jboss-mdr/lib/jboss-mdr.jar" sourcepath="/thirdparty/jboss/jboss-mdr/lib/jboss-mdr-sources.jar"/>
-	<classpathentry kind="lib" path="/thirdparty/org/jboss/javaee/lib/jboss-ejb-api.jar"/>
-	<classpathentry kind="lib" path="/thirdparty/org/jboss/javaee/lib/jboss-jacc-api.jar"/>
-	<classpathentry kind="lib" path="/thirdparty/org/jboss/javaee/lib/jboss-jad-api.jar"/>
-	<classpathentry kind="lib" path="/thirdparty/org/jboss/javaee/lib/jboss-jca-api.jar"/>
-	<classpathentry kind="lib" path="/thirdparty/org/jboss/javaee/lib/jboss-jms-api.jar"/>
-	<classpathentry kind="lib" path="/thirdparty/org/jboss/javaee/lib/jboss-transaction-api.jar"/>
+	<classpathentry kind="lib" path="/thirdparty/org/jboss/javaee/lib/jboss-javaee.jar"/>
 	<classpathentry kind="lib" path="/thirdparty/jboss/metadata/lib/jboss-metadata.jar" sourcepath="/thirdparty/jboss/metadata/lib/jboss-metadata-sources.jar"/>
 	<classpathentry combineaccessrules="false" kind="src" path="/server"/>
 	<classpathentry kind="output" path="output/eclipse-classes"/>